package com.ttu.naabrivalve.onto;

import jade.content.onto.BasicOntology;
import jade.content.onto.Ontology;
import jade.content.onto.OntologyException;
import jade.content.schema.AgentActionSchema;
import jade.content.schema.ConceptSchema;
import jade.content.schema.ObjectSchema;
import jade.content.schema.PrimitiveSchema;

/**
 * Created by ragnarp on 29.04.2015.
 */
public class CrimeWatchOntology extends Ontology implements CrimeWatchVocabulary {

    public static final String ONTOLOGY_NAME = "CrimeWatch-Ontology";
    private static Ontology instance = new CrimeWatchOntology();
    public static Ontology getInstance() {return instance;}

    private CrimeWatchOntology(){
        super(ONTOLOGY_NAME, BasicOntology.getInstance());

        try {
            ConceptSchema cs = new ConceptSchema(MESSAGE);
            add(cs, Message.class);
            cs.add(MESSAGE_CONTENT, (PrimitiveSchema)getSchema(BasicOntology.STRING), ObjectSchema.MANDATORY);

            AgentActionSchema agentActionSchema = new AgentActionSchema(REGISTER_OUT_OF_HOME);
            add(agentActionSchema, RegisterOutOfHome.class);
            agentActionSchema.add(REGISTER_OUT_OF_HOME_WHEN, (PrimitiveSchema) getSchema(BasicOntology.DATE), ObjectSchema.MANDATORY);

            add(agentActionSchema = new AgentActionSchema(REGISTER_BACK_AT_HOME), RegisterBackAtHome.class);
            agentActionSchema.add(REGISTER_BACK_AT_HOME_WHEN, (PrimitiveSchema) getSchema(BasicOntology.DATE), ObjectSchema.MANDATORY);
        } catch (OntologyException e) {
            e.printStackTrace();
        }
    }
}
